
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Club_membershipsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const club_memberships = await db.club_memberships.create(
            {
                id: data.id || undefined,
        
        club_role: data.club_role
        ||
        null
            ,
            
        member_code: data.member_code
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
        member_since_at: data.member_since_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await club_memberships.setClub( data.club || null, {
            transaction,
        });
        
        await club_memberships.setUser( data.user || null, {
            transaction,
        });
        
        await club_memberships.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return club_memberships;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const club_membershipsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                club_role: item.club_role
            ||
            null
            ,
            
                member_code: item.member_code
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
                member_since_at: item.member_since_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const club_memberships = await db.club_memberships.bulkCreate(club_membershipsData, { transaction });

        // For each item created, replace relation files
        

        return club_memberships;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const club_memberships = await db.club_memberships.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.club_role !== undefined) updatePayload.club_role = data.club_role;
        
        
        if (data.member_code !== undefined) updatePayload.member_code = data.member_code;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        if (data.member_since_at !== undefined) updatePayload.member_since_at = data.member_since_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await club_memberships.update(updatePayload, {transaction});

        
        
        if (data.club !== undefined) {
            await club_memberships.setClub(
              
              data.club,
              
              { transaction }
            );
        }
        
        if (data.user !== undefined) {
            await club_memberships.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await club_memberships.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return club_memberships;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const club_memberships = await db.club_memberships.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of club_memberships) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of club_memberships) {
                await record.destroy({transaction});
            }
        });


        return club_memberships;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const club_memberships = await db.club_memberships.findByPk(id, options);

        await club_memberships.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await club_memberships.destroy({
            transaction
        });

        return club_memberships;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const club_memberships = await db.club_memberships.findOne(
            { where },
            { transaction },
        );

        if (!club_memberships) {
            return club_memberships;
        }

        const output = club_memberships.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.club = await club_memberships.getClub({
            transaction
        });
        
        
        output.user = await club_memberships.getUser({
            transaction
        });
        
        
        output.organizations = await club_memberships.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.clubs,
        as: 'club',
        
        where: filter.club ? {
          [Op.or]: [
            { id: { [Op.in]: filter.club.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.club.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.member_code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'club_memberships',
                        'member_code',
                        filter.member_code,
                    ),
                };
            }
            

            
            

            
            if (filter.member_since_atRange) {
                const [start, end] = filter.member_since_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    member_since_at: {
                    ...where.member_since_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    member_since_at: {
                    ...where.member_since_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.club_role) {
                where = {
                    ...where,
                club_role: filter.club_role,
            };
            }
            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.club_memberships.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'club_memberships',
                        'member_code',
                        query,
                    ),
                ],
            };
        }

        const records = await db.club_memberships.findAll({
            attributes: [ 'id', 'member_code' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['member_code', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.member_code,
        }));
    }

    
};

